package ex4;


class B extends A
{
	B()
	{
		//appelle tout d'abord constructeur de A
		System.out.println("constructeur B");
	}
	protected void finalize() throws Throwable
	{
		System.out.println("destructeur B");
		// appelle explcite nécessaire si on veut que 
		//tout les detrcuteurs de la chaîne soient exécutés
		super.finalize(); 
	}
}
class C extends B
{
	C()
	{
		//appelle tout d'abord constructeur de B
		System.out.println("constructeur C");
	}
	protected void finalize() throws Throwable
	{
		System.out.println("destructeur C");
		// appelle explcite nécessaire si on veut que 
		//tout les detrcuteurs de la chaine soient exécutés
		super.finalize(); 
	}
}
public class A {
	A ()
	{
		//appelle tout d'abord constructeur de Object
		System.out.println("constructeur A");
	}
	protected void finalize() throws Throwable
	{
		System.out.println("destructeur A");
		// appelle explcite nécessaire si on veut que 
		//tout les detrcuteurs de la chaine soient exécutés
		super.finalize(); 
	}
	
	
	/*
	 * Imprime:
	 * constructeur A
	 * constructeur B
	 * constructeur C
	 * Appel System.gc()
	 * destructeur C
	 * destructeur B
	 * destructeur A
	 */
	public static void main(String[] args) {
		C c = new C(); 
		c = null; // plus de référence sur l'objet de C
		System.out.println("Appel System.gc()");
		System.gc();
	}
	
}
